package com.persagy.service;

import javax.jws.WebResult;
import javax.jws.WebService;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import com.persagy.entity.EntitySimple;
import com.persagy.entity.WSEntity_changes;
import com.persagy.entity.WSEntity_ci_status;
import com.persagy.entity.WSEntity_datas;
import com.persagy.entity.WSEntity_datas_batch;
import com.persagy.entity.WSEntity_points;
import com.persagy.entity.WSEntity_report;
import com.persagy.entity.WSEntity_report_batch;
import com.persagy.entity.WSEntity_report_change;
import com.persagy.entity.WSEntity_report_get_batch_param;
import com.persagy.wsentity.SSurvey;
import com.persagy.wsentity.SSurveyResult;
import com.persagy.wsentity2.TSurvey;
import com.persagy.wsentity2.TSurveyResult;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instance;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instances;

@WebService
@Path("/Service1_RS/")
@Produces({ "application/json" })
public interface IService1 {

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetSimple/{param}")
	public EntitySimple GetSimple(@PathParam("param") EntitySimple param);

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_GetAll")
	public Entity_ci_instances ci_instance_GetAll() throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_Get/{object_sign}/{instance_name}")
	public Entity_ci_instance ci_instance_Get(@PathParam("object_sign") String object_sign, @PathParam("instance_name") String instance_name)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_Delete/{object_sign}/{instance_name}")
	public void ci_instance_Delete(@PathParam("object_sign") String object_sign, @PathParam("instance_name") String instance_name) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_Update/{instance}")
	public void ci_instance_Update(@PathParam("instance") Entity_ci_instance instance) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_Request/{object_sign}/{instance_name}/{status_request}")
	public void ci_instance_Request(@PathParam("object_sign") String object_sign, @PathParam("instance_name") String instance_name,
			@PathParam("status_request") String status_request) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_interval/{object_sign}/{instance_name}/{interval}")
	public void ci_instance_interval(@PathParam("object_sign") String object_sign, @PathParam("instance_name") String instance_name,
			@PathParam("interval") long interval) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ci_instance_status/{object_sign}/{instance_name}")
	public WSEntity_ci_status ci_instance_status(@PathParam("object_sign") String object_sign, @PathParam("instance_name") String instance_name)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("Survey_Delete/{survey}")
	public void Survey_Delete(@PathParam("survey") SSurvey survey) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("Survey_Update/{survey}")
	public SSurveyResult Survey_Update(@PathParam("survey") SSurvey survey) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("Survey_Delete2/{survey}")
	public void Survey_Delete2(@PathParam("survey") TSurvey survey) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("Survey_Update2/{survey}")
	public TSurveyResult Survey_Update2(@PathParam("survey") TSurvey survey) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("servicedata_recompute/{object_sign}/{compute_time_from}")
	public String servicedata_recompute(@PathParam("object_sign") String object_sign, @PathParam("compute_time_from") String compute_time_from)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("EMS_recompute/{object_sign}/{compute_time_from}")
	public String EMS_recompute(@PathParam("object_sign") String object_sign, @PathParam("compute_time_from") String compute_time_from)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("fjd_recompute/{building}/{compute_time}")
	public String fjd_recompute(@PathParam("building") String building, @PathParam("compute_time") String compute_time) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("fjd_0_buildingcomputetime/{building}")
	public String fjd_0_buildingcomputetime(@PathParam("building") String building) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("fjd_0_buildingcomputetime_delete/{building}")
	public void fjd_0_buildingcomputetime_delete(@PathParam("building") String building) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("fjd_0_compute_request/{building}/{compute_time_from}/{compute_time_to}")
	public void fjd_0_compute_request(@PathParam("building") String building, @PathParam("compute_time_from") String compute_time_from,
			@PathParam("compute_time_to") String compute_time_to) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("fjd_0_compute_request_by_model/{building}/{modelSign}/{compute_time_from}/{compute_time_to}")
	public void fjd_0_compute_request_by_model(@PathParam("building") String building, @PathParam("modelSign") String modelSign,
			@PathParam("compute_time_from") String compute_time_from, @PathParam("compute_time_to") String compute_time_to) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_dy_pointlist/{building}")
	public WSEntity_points get_dy_pointlist(@PathParam("building") String building) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_dy_reportpointlist/{building}")
	public WSEntity_points get_dy_reportpointlist(@PathParam("building") String building) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ini_fjd_0_buildingcomputetime/{building}/{compute_time}")
	public void ini_fjd_0_buildingcomputetime(@PathParam("building") String building, @PathParam("compute_time") String compute_time)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("ini_dy_pointlist/{points}")
	public void ini_dy_pointlist(@PathParam("points") WSEntity_points points) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("set_fjd_0_buildingcomputetime/{building}/{compute_time}")
	public void set_fjd_0_buildingcomputetime(@PathParam("building") String building, @PathParam("compute_time") String compute_time)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("set_fjd_0_buildingcomputetime_by_model/{building}/{energyModelSign}/{compute_time}")
	public String set_fjd_0_buildingcomputetime_by_model(@PathParam("building") String building, @PathParam("energyModelSign") String energyModelSign,
			@PathParam("compute_time") String compute_time) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("set_dy_pointlist/{points}")
	public String set_dy_pointlist(@PathParam("points") WSEntity_points points) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("set_dy_reportpointlist/{points}")
	public String set_dy_reportpointlist(@PathParam("points") WSEntity_points points) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("report/{pointdata}")
	public void report(@PathParam("pointdata") WSEntity_report pointdata) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("report_batch/{data_batch}")
	public void report_batch(@PathParam("data_batch") WSEntity_report_batch data_batch) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("reportenergy/{pointdata}")
	public void reportenergy(@PathParam("pointdata") WSEntity_report pointdata) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("reportenergy_batch/{data_batch}")
	public void reportenergy_batch(@PathParam("data_batch") WSEntity_report_batch data_batch) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_reportdatalist/{building}/{meter}/{funcid}/{time_from}/{time_to}")
	public WSEntity_datas get_reportdatalist(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") Long funcid, @PathParam("time_from") String time_from, @PathParam("time_to") String time_to) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_reportdatalist_batch/{param_entity}")
	public WSEntity_datas_batch get_reportdatalist_batch(@PathParam("param_entity") WSEntity_report_get_batch_param param_entity) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_reportenergylist/{building}/{meter}/{funcid}/{time_from}/{time_to}")
	public WSEntity_datas get_reportenergylist(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") Long funcid, @PathParam("time_from") String time_from, @PathParam("time_to") String time_to) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_reportenergylist_batch/{param_entity}")
	public WSEntity_datas_batch get_reportenergylist_batch(@PathParam("param_entity") WSEntity_report_get_batch_param param_entity) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("report_change/{pointdata}")
	public void report_change(@PathParam("pointdata") WSEntity_report_change pointdata) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("get_reportdatalist_change/{building}")
	public WSEntity_changes get_reportdatalist_change(@PathParam("building") String building) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_report")
	public void post_report(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_report_batch")
	public void post_report_batch(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportenergy")
	public void post_reportenergy(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportenergy_batch")
	public void post_reportenergy_batch(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_report_change")
	public void post_report_change(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportdatalist")
	public WSEntity_datas post_reportdatalist(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportdatalist_batch")
	public WSEntity_datas_batch post_reportdatalist_batch(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportenergylist")
	public WSEntity_datas post_reportenergylist(String param) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("post_reportenergylist_batch")
	public WSEntity_datas_batch post_reportenergylist_batch(String param) throws Exception;

}
