package com.persagy.service;

import javax.jws.WebResult;
import javax.jws.WebService;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import com.persagy.entity.EntityDynamicData;
import com.persagy.entity.EntityDynamicDataArray;

@WebService
@Path("/ServiceDynamicData_RS/")
@Produces({ "application/json" })
public interface IServiceDynamicData {

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("test")
	public String test();

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetOriginalPresent/{building}/{meter}/{funcid}")
	public EntityDynamicData GetOriginalPresent(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") long funcid) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetOriginalArray/{building}/{meter}/{funcid}/{timefrom}/{timeto}")
	public EntityDynamicDataArray GetOriginalArray(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") long funcid, @PathParam("timefrom") String timefrom, @PathParam("timeto") String timeto) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetFJDArray/{building}/{meter}/{funcid}/{time_period}/{timefrom}/{timeto}")
	public EntityDynamicDataArray GetFJDArray(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") long funcid, @PathParam("time_period") String time_period, @PathParam("timefrom") String timefrom,
			@PathParam("timeto") String timeto) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetServiceDataArray/{building}/{meter}/{funcid}/{time_period}/{timefrom}/{timeto}")
	public EntityDynamicDataArray GetServiceDataArray(@PathParam("building") String building, @PathParam("meter") String meter,
			@PathParam("funcid") long funcid, @PathParam("time_period") String time_period, @PathParam("timefrom") String timefrom,
			@PathParam("timeto") String timeto) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetObjectDataArray/{building}/{object_id}/{time_period}/{timefrom}/{timeto}")
	public EntityDynamicDataArray GetObjectDataArray(@PathParam("building") String building, @PathParam("object_id") String object_id,
			@PathParam("time_period") String time_period, @PathParam("timefrom") String timefrom, @PathParam("timeto") String timeto)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("GetEnergyDataArray/{building}/{mode_sign}/{mode_node_sign}/{time_period}/{timefrom}/{timeto}")
	public EntityDynamicDataArray GetEnergyDataArray(@PathParam("building") String building, @PathParam("mode_sign") String mode_sign,
			@PathParam("mode_node_sign") String mode_node_sign, @PathParam("time_period") String time_period, @PathParam("timefrom") String timefrom,
			@PathParam("timeto") String timeto) throws Exception;

}
