package com.persagy.service;

import javax.jws.WebResult;
import javax.jws.WebService;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;

import com.persagy.entity.EntitySimple;
import com.persagy.entity.WSEntity_tenant;
import com.persagy.entity.WSEntity_tenants;

@WebService
@Path("/ServiceTenant_RS/")
@Produces({ "application/json" })
public interface IServiceTenant {

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("GetSimple")
	public EntitySimple GetSimple(String str);

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("AddTenant")
	public void AddTenant(String str) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("AddTenants")
	public void AddTenants(String str) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("ModifyTenantPrice")
	public void ModifyTenantPrice(String str) throws Exception;

	@WebResult
	@POST
	@Produces({ "application/json" })
	@Path("ModifyTenantPrice_before")
	public void ModifyTenantPrice_before(String str) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("DeleteTenant/{building}/{sign}")
	public void DeleteTenant(@PathParam("building") String building, @PathParam("sign") String sign)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("StopTenant/{building}/{sign}/{valid_time_to}")
	public void StopTenant(@PathParam("building") String building, @PathParam("sign") String sign, @PathParam("valid_time_to") String valid_time_to)
			throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("RechargeTenant/{building}/{sign}/{operate_time}/{amount}")
	public void RechargeTenant(@PathParam("building") String building, @PathParam("sign") String sign, @PathParam("operate_time") String operate_time,
			@PathParam("amount") Double amount) throws Exception;

	@WebResult
	@GET
	@Produces({ "application/json" })
	@Path("RechargeTenantEnergy/{building}/{sign}/{energy_type}/{operate_time}/{amount}")
	public void RechargeTenantEnergy(@PathParam("building") String building, @PathParam("sign") String sign,
			@PathParam("energy_type") String energy_type, @PathParam("operate_time") String operate_time, @PathParam("amount") Double amount)
			throws Exception;
}
