package com.persagy.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.EntityDynamicData;
import com.persagy.entity.EntityDynamicDataArray;
import com.persagy.util.DynamicDataUtil;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.sagacloud.util.compute_engine.util.QueryUtil_fjd;

import javax.jws.WebResult;
import javax.jws.WebService;
import java.util.List;

@WebService(endpointInterface = "com.persagy.service.IServiceDynamicData")
public class ServiceDynamicDataImpl implements IServiceDynamicData {
	@Override
	@WebResult
	public String test() {
		return "hello";
	}

	@Override
	@WebResult
	public EntityDynamicData GetOriginalPresent(String building, String meter, long funcid) throws Exception {
		EntityDynamicData result = null;
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONArray Content = QueryUtil.select(ConstantCE.database_name, "original_present", Criteria);
		if (Content.size() > 0) {
			result = DynamicDataUtil.Convert_original(Content.getJSONObject(0));
		}
		return result;
	}

	@Override
	@WebResult
	public EntityDynamicDataArray GetOriginalArray(String building, String meter, long funcid, String timefrom, String timeto) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject Range = new JSONObject();
		Range.put("$gte", timefrom);
		Range.put("$lte", timeto);
		Criteria.put("receivetime", Range);
		JSONArray Content = QueryUtil.select(ConstantCE.database_name, "original_month", Criteria);
		EntityDynamicDataArray result = DynamicDataUtil.ConvertArray_original(Content);
		return result;
	}

	@Override
	@WebResult
	public EntityDynamicDataArray GetFJDArray(String building, String meter, long funcid, String time_period, String timefrom, String timeto)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject Range = new JSONObject();
		Range.put("$gte", timefrom);
		Range.put("$lte", timeto);
		Criteria.put("receivetime", Range);
		List<DoubleTimeObject> dataList = QueryUtil_fjd.get_fjd_merge(ConstantCE.database_name, building, meter,
				funcid, time_period, timefrom, timeto, true, false);
		EntityDynamicDataArray result = DynamicDataUtil.ConvertArray(dataList);
		return result;
	}

	@Override
	@WebResult
	public EntityDynamicDataArray GetServiceDataArray(String building, String meter, long funcid, String time_period, String timefrom, String timeto)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject Range = new JSONObject();
		Range.put("$gte", timefrom);
		Range.put("$lt", timeto);
		Criteria.put("data_time", Range);
		JSONArray Content = QueryUtil.select( ConstantCE.database_name, "data_servicedata_" + time_period,
				Criteria);
		EntityDynamicDataArray result = DynamicDataUtil.ConvertArray(Content);
		return result;
	}

	@Override
	public EntityDynamicDataArray GetObjectDataArray(String building, String object_id, String time_period, String timefrom, String timeto)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("objectSign", object_id);
		JSONObject Range = new JSONObject();
		Range.put("$gte", timefrom);
		Range.put("$lt", timeto);
		Criteria.put("data_time", Range);
		JSONArray Content = QueryUtil.select( ConstantCE.database_name, "data_objectdata_" + time_period,
				Criteria);
		EntityDynamicDataArray result = DynamicDataUtil.ConvertArray(Content);
		return result;
	}

	@Override
	public EntityDynamicDataArray GetEnergyDataArray(String building, String mode_sign, String mode_node_sign, String time_period, String timefrom,
													 String timeto) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("energyModelSign", mode_sign);
		Criteria.put("energyModelNodeSign", mode_node_sign);
		JSONObject Range = new JSONObject();
		Range.put("$gte", timefrom);
		Range.put("$lt", timeto);
		Criteria.put("data_time", Range);
		JSONArray Content = QueryUtil.select(ConstantCE.database_name, "data_energydata_" + time_period,
				Criteria);
		EntityDynamicDataArray result = DynamicDataUtil.ConvertArray(Content);
		return result;
	}
}
