package com.persagy.service;

import java.util.Date;

import javax.jws.WebResult;
import javax.jws.WebService;

import com.persagy.entity.EntitySimple;
import com.persagy.entity.WSEntity_changes;
import com.persagy.entity.WSEntity_ci_status;
import com.persagy.entity.WSEntity_datas;
import com.persagy.entity.WSEntity_datas_batch;
import com.persagy.entity.WSEntity_points;
import com.persagy.entity.WSEntity_report;
import com.persagy.entity.WSEntity_report_batch;
import com.persagy.entity.WSEntity_report_change;
import com.persagy.entity.WSEntity_report_get_batch_param;
import com.persagy.entity.WSEntity_report_get_param;
import com.persagy.wsentity.SSurvey;
import com.persagy.wsentity.SSurveyResult;
import com.persagy.wsentity2.TSurvey;
import com.persagy.wsentity2.TSurveyResult;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instance;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instances;

@WebService(endpointInterface = "com.persagy.service.IService1")
public class ServiceImpl1 implements IService1 {
	@WebResult
	public EntitySimple GetSimple(EntitySimple param) {
		return param;
	}

	@WebResult
	public Entity_ci_instances ci_instance_GetAll() throws Exception {
		Entity_ci_instances result = ServiceUtil.ci_instance_GetAll();
		return result;
	}

	@WebResult
	public Entity_ci_instance ci_instance_Get(String object_sign, String instance_name) throws Exception {
		Entity_ci_instance result = ServiceUtil.ci_instance_Get(object_sign, instance_name);
		return result;
	}

	@WebResult
	public void ci_instance_Update(Entity_ci_instance instance) throws Exception {
		ServiceUtil.ci_instance_Update(instance);
	}

	@WebResult
	public void ci_instance_Delete(String object_sign, String instance_name) throws Exception {
		ServiceUtil.ci_instance_Delete(object_sign, instance_name);
	}

	@WebResult
	public void ci_instance_Request(String object_sign, String instance_name, String status_request) throws Exception {
		ServiceUtil.ci_instance_Request(object_sign, instance_name, status_request);
	}

	@WebResult
	public void ci_instance_interval(String object_sign, String instance_name, long interval) throws Exception {
		ServiceUtil.ci_instance_interval(object_sign, instance_name, interval);
	}

	@WebResult
	public WSEntity_ci_status ci_instance_status(String object_sign, String instance_name) throws Exception {
		WSEntity_ci_status result = ServiceUtil.ci_instance_status(object_sign, instance_name);
		return result;
	}

	@WebResult
	public void Survey_Delete(SSurvey survey) throws Exception {
		ServiceUtil.Survey_Delete(survey);
	}

	@WebResult
	public SSurveyResult Survey_Update(SSurvey survey) throws Exception {
		SSurveyResult result = ServiceUtil.Survey_Update(survey);
		return result;
	}

	@WebResult
	public void Survey_Delete2(TSurvey survey) throws Exception {
		ServiceUtil.Survey_Delete2(survey);
	}

	@WebResult
	public TSurveyResult Survey_Update2(TSurvey survey) throws Exception {
		TSurveyResult result = ServiceUtil.Survey_Update2(survey);
		return result;
	}

	@WebResult
	public String servicedata_recompute(String object_sign, String time) throws Exception {
		return ServiceUtil.servicedata_recompute(object_sign, time);
	}

	@WebResult
	public String EMS_recompute(String object_sign, String time) throws Exception {
		return ServiceUtil.EMS_recompute(object_sign, time);
	}

	@WebResult
	public String fjd_recompute(String building, String compute_time) throws Exception {
		ServiceUtil.set_fjd_0_buildingcomputetime(building, compute_time, false);
		return null;
	}

	@WebResult
	public String fjd_0_buildingcomputetime(String building) throws Exception {
		String result = ServiceUtil.get_fjd_0_buildingcomputetime(building);
		return result;
	}

	@WebResult
	public void fjd_0_buildingcomputetime_delete(String building) throws Exception {
		ServiceUtil.fjd_0_buildingcomputetime_delete(building);
	}

	@WebResult
	public void fjd_0_compute_request(String building, String compute_time_from, String compute_time_to) throws Exception {
		ServiceUtil.fjd_0_compute_request(building, compute_time_from, compute_time_to);
	}

	@WebResult
	public void fjd_0_compute_request_by_model(String building, String modelSign, String compute_time_from, String compute_time_to) throws Exception {
		ServiceUtil.fjd_0_compute_request_by_model(building, modelSign, compute_time_from, compute_time_to);
	}

	@WebResult
	public WSEntity_points get_dy_pointlist(String building) throws Exception {
		WSEntity_points result = ServiceUtil.get_dy_pointlist(building, false);
		return result;
	}

	@WebResult
	public WSEntity_points get_dy_reportpointlist(String building) throws Exception {
		WSEntity_points result = ServiceUtil.get_dy_pointlist(building, true);
		return result;
	}

	@WebResult
	public void ini_fjd_0_buildingcomputetime(String building, String compute_time) throws Exception {
		ServiceUtil.set_fjd_0_buildingcomputetime(building, compute_time, true);
	}

	@WebResult
	public void ini_dy_pointlist(WSEntity_points points) throws Exception {
		ServiceUtil.set_dy_pointlist(points, false, "Other");
	}

	@WebResult
	public void set_fjd_0_buildingcomputetime(String building, String compute_time) throws Exception {
		ServiceUtil.set_fjd_0_buildingcomputetime(building, compute_time, false);
	}

	@WebResult
	public String set_fjd_0_buildingcomputetime_by_model(String building, String energyModelSign, String compute_time) throws Exception {
		String result = ServiceUtil.set_fjd_0_buildingcomputetime_by_model(building, energyModelSign, compute_time);
		return result;
	}

	@WebResult
	public String set_dy_pointlist(WSEntity_points points) throws Exception {
		String result = ServiceUtil.set_dy_pointlist(points, false, "Other");
		return result;
	}

	@WebResult
	public String set_dy_reportpointlist(WSEntity_points points) throws Exception {
		String result = ServiceUtil.set_dy_pointlist(points, true, "Other");
		return result;
	}

	@WebResult
	public void report(WSEntity_report pointdata) throws Exception {
		Date curr_time = new Date();
		ServiceUtil.report(pointdata, false, curr_time);
	}

	@WebResult
	public void report_batch(WSEntity_report_batch data_batch) throws Exception {
		Date curr_time = new Date();
		WSEntity_report[] data_array = data_batch.getData_array();
		for (int i = 0; i < data_array.length; i++) {
			WSEntity_report data = data_array[i];
			if (data_batch.getBuilding() != null) {
				data.setBuilding(data_batch.getBuilding());
			}
			ServiceUtil.report(data, false, curr_time);
		}
	}

	@WebResult
	public void reportenergy(WSEntity_report pointdata) throws Exception {
		Date curr_time = new Date();
		ServiceUtil.report(pointdata, true, curr_time);
	}

	@WebResult
	public void reportenergy_batch(WSEntity_report_batch data_batch) throws Exception {
		Date curr_time = new Date();
		WSEntity_report[] data_array = data_batch.getData_array();
		for (int i = 0; i < data_array.length; i++) {
			WSEntity_report data = data_array[i];
			if (data_batch.getBuilding() != null) {
				data.setBuilding(data_batch.getBuilding());
			}
			ServiceUtil.report(data, true, curr_time);
		}
	}

	@WebResult
	public WSEntity_datas get_reportdatalist(String building, String meter, Long funcid, String time_from, String time_to) throws Exception {
		WSEntity_datas result = ServiceUtil.get_reportdatalist(building, "read_data", meter, funcid, time_from, time_to);
		return result;
	}

	@WebResult
	public WSEntity_datas_batch get_reportdatalist_batch(WSEntity_report_get_batch_param param_entity) throws Exception {
		String building = param_entity.getBuilding();
		String time_from = param_entity.getTime_from();
		String time_to = param_entity.getTime_to();
		int point_count = param_entity.getMeter_array().length;
		WSEntity_datas[] data_array = new WSEntity_datas[point_count];
		for (int i = 0; i < point_count; i++) {
			String meter = param_entity.getMeter_array()[i];
			long funcid = param_entity.getFuncid_array()[i];
			data_array[i] = ServiceUtil.get_reportdatalist(building, "read_data", meter, funcid, time_from, time_to);
		}
		WSEntity_datas_batch result = new WSEntity_datas_batch();
		result.setBuilding(building);
		result.setData_array(data_array);
		return result;
	}

	@WebResult
	public WSEntity_datas get_reportenergylist(String building, String meter, Long funcid, String time_from, String time_to) throws Exception {
		WSEntity_datas result = ServiceUtil.get_reportdatalist(building, "energy", meter, funcid, time_from, time_to);
		return result;
	}

	@WebResult
	public WSEntity_datas_batch get_reportenergylist_batch(WSEntity_report_get_batch_param param_entity) throws Exception {
		String building = param_entity.getBuilding();
		String time_from = param_entity.getTime_from();
		String time_to = param_entity.getTime_to();
		int point_count = param_entity.getMeter_array().length;
		WSEntity_datas[] data_array = new WSEntity_datas[point_count];
		for (int i = 0; i < point_count; i++) {
			String meter = param_entity.getMeter_array()[i];
			long funcid = param_entity.getFuncid_array()[i];
			data_array[i] = ServiceUtil.get_reportdatalist(building, "energy", meter, funcid, time_from, time_to);
		}
		WSEntity_datas_batch result = new WSEntity_datas_batch();
		result.setBuilding(building);
		result.setData_array(data_array);
		return result;
	}

	@WebResult
	public void report_change(WSEntity_report_change pointdata) throws Exception {
		ServiceUtil.report_change(pointdata);
	}

	@WebResult
	public WSEntity_changes get_reportdatalist_change(String building) throws Exception {
		WSEntity_changes result = ServiceUtil.get_reportdatalist_change(building);
		return result;
	}

	@WebResult
	public void post_report(String param) throws Exception {
		Date curr_time = new Date();
		WSEntity_report pointdata = new WSEntity_report(param);
		ServiceUtil.report(pointdata, false, curr_time);
	}

	@WebResult
	public void post_report_batch(String param) throws Exception {
		Date curr_time = new Date();
		WSEntity_report_batch data_batch = new WSEntity_report_batch(param);
		WSEntity_report[] data_array = data_batch.getData_array();
		for (int i = 0; i < data_array.length; i++) {
			WSEntity_report data = data_array[i];
			if (data_batch.getBuilding() != null) {
				data.setBuilding(data_batch.getBuilding());
			}
			ServiceUtil.report(data, false, curr_time);
		}
	}

	@WebResult
	public void post_reportenergy(String param) throws Exception {
		Date curr_time = new Date();
		WSEntity_report pointdata = new WSEntity_report(param);
		ServiceUtil.report(pointdata, true, curr_time);
	}

	@WebResult
	public void post_reportenergy_batch(String param) throws Exception {
		Date curr_time = new Date();
		WSEntity_report_batch data_batch = new WSEntity_report_batch(param);
		WSEntity_report[] data_array = data_batch.getData_array();
		for (int i = 0; i < data_array.length; i++) {
			WSEntity_report data = data_array[i];
			if (data_batch.getBuilding() != null) {
				data.setBuilding(data_batch.getBuilding());
			}
			ServiceUtil.report(data, true, curr_time);
		}
	}

	@WebResult
	public void post_report_change(String param) throws Exception {
		WSEntity_report_change pointdata = new WSEntity_report_change(param);
		ServiceUtil.report_change(pointdata);
	}

	@WebResult
	public WSEntity_datas post_reportdatalist(String param) throws Exception {
		WSEntity_report_get_param param_entity = new WSEntity_report_get_param(param);
		WSEntity_datas result = ServiceUtil.get_reportdatalist(param_entity.getBuilding(), "read_data", param_entity.getMeter(),
				param_entity.getFuncid(), param_entity.getTime_from(), param_entity.getTime_to());
		return result;
	}

	@WebResult
	public WSEntity_datas_batch post_reportdatalist_batch(String param) throws Exception {
		WSEntity_report_get_batch_param param_entity = new WSEntity_report_get_batch_param(param);
		String building = param_entity.getBuilding();
		String time_from = param_entity.getTime_from();
		String time_to = param_entity.getTime_to();
		int point_count = param_entity.getMeter_array().length;
		WSEntity_datas[] data_array = new WSEntity_datas[point_count];
		for (int i = 0; i < point_count; i++) {
			String meter = param_entity.getMeter_array()[i];
			long funcid = param_entity.getFuncid_array()[i];
			data_array[i] = ServiceUtil.get_reportdatalist(building, "read_data", meter, funcid, time_from, time_to);
		}
		WSEntity_datas_batch result = new WSEntity_datas_batch();
		result.setBuilding(building);
		result.setData_array(data_array);
		return result;
	}

	@WebResult
	public WSEntity_datas post_reportenergylist(String param) throws Exception {
		WSEntity_report_get_param param_entity = new WSEntity_report_get_param(param);
		WSEntity_datas result = ServiceUtil.get_reportdatalist(param_entity.getBuilding(), "energy", param_entity.getMeter(),
				param_entity.getFuncid(), param_entity.getTime_from(), param_entity.getTime_to());
		return result;
	}

	@WebResult
	public WSEntity_datas_batch post_reportenergylist_batch(String param) throws Exception {
		WSEntity_report_get_batch_param param_entity = new WSEntity_report_get_batch_param(param);
		String building = param_entity.getBuilding();
		String time_from = param_entity.getTime_from();
		String time_to = param_entity.getTime_to();
		int point_count = param_entity.getMeter_array().length;
		WSEntity_datas[] data_array = new WSEntity_datas[point_count];
		for (int i = 0; i < point_count; i++) {
			String meter = param_entity.getMeter_array()[i];
			long funcid = param_entity.getFuncid_array()[i];
			data_array[i] = ServiceUtil.get_reportdatalist(building, "energy", meter, funcid, time_from, time_to);
		}
		WSEntity_datas_batch result = new WSEntity_datas_batch();
		result.setBuilding(building);
		result.setData_array(data_array);
		return result;
	}
}
