package com.persagy.service;

import java.util.ArrayList;
import java.util.List;

import javax.jws.WebResult;
import javax.jws.WebService;

import org.zillion.util.json.FastJsonReaderUtil;

import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.EntitySimple;
import com.persagy.entity.WSEntity_tenant;
import com.persagy.entity.WSEntity_tenants;

@WebService(endpointInterface = "com.persagy.service.IServiceTenant")
public class ServiceTenant implements IServiceTenant {
	@WebResult
	public EntitySimple GetSimple(String str) {
		return new EntitySimple(str);
	}

	@WebResult
	public void AddTenant(String str) throws Exception {
		WSEntity_tenant param = new WSEntity_tenant(str);
		List<WSEntity_tenant> tenantList = new ArrayList<WSEntity_tenant>();
		tenantList.add(param);
		ServiceTenantUtil.AddTenant(tenantList);
	}

	@WebResult
	public void AddTenants(String str) throws Exception {
		WSEntity_tenants param = new WSEntity_tenants(str);
		List<WSEntity_tenant> tenantList = new ArrayList<WSEntity_tenant>();
		WSEntity_tenant[] tenants = param.getTenants();
		for (WSEntity_tenant tenant : tenants) {
			if (tenant.getBuilding() == null) {
				tenant.setBuilding(param.getBuilding());
			}
			tenantList.add(tenant);
		}
		ServiceTenantUtil.AddTenant(tenantList);
	}

	@WebResult
	public void ModifyTenantPrice(String str) throws Exception {
		JSONObject param = (JSONObject) FastJsonReaderUtil.Instance().parse(str);
		String building = (String) param.get("building");
		String sign = (String) param.get("sign");
		String energy_type = (String) param.get("energy_type");
		String valid_time_from = (String) param.get("valid_time_from");
		String price_content = (String) param.get("price_content");
		ServiceTenantUtil.ModifyTenantPrice(building, sign, energy_type, valid_time_from, price_content);
	}

	@WebResult
	public void ModifyTenantPrice_before(String str) throws Exception {
		JSONObject param = (JSONObject) FastJsonReaderUtil.Instance().parse(str);
		String building = (String) param.get("building");
		String sign = (String) param.get("sign");
		String energy_type = (String) param.get("energy_type");
		String valid_time_from = (String) param.get("valid_time_from");
		String price_content = (String) param.get("price_content");
		ServiceTenantUtil.ModifyTenantPrice_before(building, sign, energy_type, valid_time_from, price_content);
	}

	@WebResult
	public void DeleteTenant(String building, String sign) throws Exception {
		ServiceTenantUtil.DeleteTenant(building, sign);
	}

	@WebResult
	public void StopTenant(String building, String sign, String valid_time_to) throws Exception {
		ServiceTenantUtil.StopTenant(building, sign, valid_time_to);
	}

	@WebResult
	public void RechargeTenant(String building, String sign, String operate_time, Double amount) throws Exception {
		ServiceTenantUtil.RechargeTenant(building, sign, operate_time, amount);
	}

	@WebResult
	public void RechargeTenantEnergy(String building, String sign, String energy_type, String operate_time, Double amount) throws Exception {
		ServiceTenantUtil.RechargeTenantEnergy(building, sign, energy_type, operate_time, amount);
	}
}
