package com.persagy.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.WSEntity_point;
import com.persagy.entity.WSEntity_tenant;
import com.persagy.entity.WSEntity_tenant_energy;
import com.persagy.entity.WSEntity_tenant_energy_meter;
import com.persagy.util.ConstantWeb;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instance;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instanceinput;
import com.sagacloud.util.compute_engine.entity.Entity_ci_instanceoutput;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.InstanceUtil;
import com.sagacloud.util.compute_engine.util.QueryUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ServiceTenantUtil {
	public static void AddTenant(List<WSEntity_tenant> tenantList) throws Exception {
		JSONArray InsertObjects_tenant = new JSONArray();
		JSONArray InsertObjects_energy = new JSONArray();
		JSONArray InsertObjects_price = new JSONArray();
		JSONArray InsertObjects_meter = new JSONArray();
		JSONArray InsertObjects_point = new JSONArray();
		Map<String, WSEntity_point> pointMap = new HashMap<String, WSEntity_point>();
		Map<String, Double> InputCTMap = new HashMap<String, Double>();
		String building = null;
		for (WSEntity_tenant tenant : tenantList) {
			building = tenant.getBuilding();
			JSONObject InsertObject_tenant = new JSONObject();
			InsertObject_tenant.put("building", tenant.getBuilding());
			InsertObject_tenant.put("sign", tenant.getSign());
			InsertObject_tenant.put("valid_time_from", tenant.getValid_time_from());
			InsertObject_tenant.put("soft_enable", tenant.getSoft_enable());
			InsertObject_tenant.put("soft_initial_yuer", tenant.getSoft_initial_yuer());
			InsertObjects_tenant.add(InsertObject_tenant);
			if (tenant.getEnergys() == null) {
				continue;
			}
			WSEntity_tenant_energy[] energys = tenant.getEnergys();
			for (WSEntity_tenant_energy energy : energys) {
				JSONObject InsertObject_energy = new JSONObject();
				InsertObject_energy.put("building", tenant.getBuilding());
				InsertObject_energy.put("sign", tenant.getSign());
				InsertObject_energy.put("energy_type", energy.getEnergy_type());
				InsertObject_energy.put("price_type", energy.getPrice_type());
				InsertObject_energy.put("soft_enable", energy.getSoft_enable());
				InsertObject_energy.put("soft_initial_yuer", energy.getSoft_initial_yuer());
				InsertObjects_energy.add(InsertObject_energy);

				JSONObject InsertObject_price = new JSONObject();
				InsertObject_price.put("building", tenant.getBuilding());
				InsertObject_price.put("sign", tenant.getSign());
				InsertObject_price.put("energy_type", energy.getEnergy_type());

				InsertObject_price.put("price_content", energy.getPrice_content());
				InsertObjects_price.add(InsertObject_price);

				if (energy.getMeters() == null) {
					continue;
				}
				WSEntity_tenant_energy_meter[] meters = energy.getMeters();
				for (WSEntity_tenant_energy_meter meter : meters) {
					JSONObject InsertObject_meter = new JSONObject();
					InsertObject_meter.put("building", tenant.getBuilding());
					InsertObject_meter.put("sign", tenant.getSign());
					InsertObject_meter.put("energy_type", energy.getEnergy_type());
					InsertObject_meter.put("meter_sign", meter.getMeter_sign());
					InsertObject_meter.put("share_ratio", meter.getShare_ratio());
					InsertObject_meter.put("transformer_ratio", meter.getTransformer_ratio());
					InsertObjects_meter.add(InsertObject_meter);
					for (WSEntity_point point : meter.getPoints()) {
						point.setMeter(meter.getMeter_sign());
						String point_real_name = meter.getMeter_sign() + "_" + point.getFuncid();
						if (meter.getTransformer_ratio() != null) {
							InputCTMap.put(point_real_name, meter.getTransformer_ratio());
						}
						pointMap.put(point_real_name, point);
						JSONObject InsertObject_point = new JSONObject();
						InsertObject_point.put("building", tenant.getBuilding());
						InsertObject_point.put("meter", point.getMeter());
						InsertObject_point.put("funcid", point.getFuncid());
						InsertObject_point.put("data_type", point.getData_type());
						InsertObject_point.put("collect_cycle", point.getCollect_cycle());
						InsertObject_point.put("system", "tenant");
						InsertObjects_point.add(InsertObject_point);
					}
				}
			}
		}
		QueryUtil.batch_insert(ConstantCE.database_name, "tenant_energy_price", InsertObjects_price);
		QueryUtil.batch_insert(ConstantCE.database_name, "tenant_energy_meter", InsertObjects_meter);
		QueryUtil.batch_insert(ConstantCE.database_name, "tenant_energy", InsertObjects_energy);
		QueryUtil.batch_insert(ConstantCE.database_name, "tenant", InsertObjects_tenant);
		QueryUtil.batch_insert(ConstantCE.database_name, "dy_pointlist", InsertObjects_point);

		String instance_name = "servicedataoftenant";
		List<WSEntity_point> pointList = new ArrayList<WSEntity_point>();
		pointList.addAll(pointMap.values());

		Entity_ci_instance instance_exist = InstanceUtil.Get(ConstantCE.database_name, building, instance_name);
		Entity_ci_instance instance = SurveyUtil2.Generate_servicedata(building, instance_name, pointList, InputCTMap);
		if (instance_exist == null) {
			ServiceUtil.ci_instance_Update(instance);
		} else {
			InstanceUtil.Insert(ConstantCE.database_name, instance);
		}
		if (ConstantWeb.name2interval.containsKey(instance_name + "_max")) {
			Entity_ci_instance instance_max = SurveyUtil.Convert_max(instance);
			ServiceUtil.ci_instance_Update(instance_max);
			if (instance_exist == null) {
				ServiceUtil.ci_instance_Update(instance_max);
			} else {
				InstanceUtil.Insert(ConstantCE.database_name, instance_max);
			}
		}
		{
			Entity_ci_instance instance_tenant = new Entity_ci_instance();
			instance_tenant.setObject_sign(building);
			instance_tenant.setInstance_name("tenant");
			instance_tenant.setFlag_valid(1L);
			instance_tenant.setCompute_interval_seconds(ConstantWeb.name2interval.get("tenant"));
			instance_tenant.setInputs(new Entity_ci_instanceinput[0]);
			instance_tenant.setOutputs(new Entity_ci_instanceoutput[0]);
			ServiceUtil.ci_instance_Update(instance_tenant);
			if (ConstantWeb.name2interval.containsKey("tenant" + "_max")) {
				Entity_ci_instance instance_max = SurveyUtil.Convert_max(instance_tenant);
				ServiceUtil.ci_instance_Update(instance_max);
				if (instance_exist == null) {
					ServiceUtil.ci_instance_Update(instance_max);
				} else {
					InstanceUtil.Insert(ConstantCE.database_name, instance_max);
				}
			}
		}
	}

	public static void DeleteTenant(String building, String sign) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("sign", sign);
		QueryUtil.delete(ConstantCE.database_name, "tenant", Criteria);
		QueryUtil.delete(ConstantCE.database_name, "tenant_energy", Criteria);
		QueryUtil.delete(ConstantCE.database_name, "tenant_energy_meter", Criteria);
		QueryUtil.delete(ConstantCE.database_name, "tenant_energy_price", Criteria);
		QueryUtil.delete(ConstantCE.database_name, "tenant_recharge", Criteria);
	}

	public static void StopTenant(String building, String sign, String valid_time_to) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("sign", sign);
		JSONObject Set = new JSONObject();
		Set.put("valid_time_to", valid_time_to);
		QueryUtil.update(ConstantCE.database_name, "tenant", Criteria, Set);
	}

	public static void ModifyTenantPrice(String building, String sign, String energy_type, String valid_time_from, String price_content)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("sign", sign);
		Criteria.put("energy_type", energy_type);
		JSONArray Content = QueryUtil.select(ConstantCE.database_name, "tenant_energy_price", Criteria);
		for (int i = 0; i < Content.size(); i++) {
			JSONObject price = (JSONObject) Content.get(i);
			JSONObject priceNext = null;
			if (i < Content.size() - 1) {
				priceNext = (JSONObject) Content.get(i + 1);
			}
			if (priceNext == null) {
				JSONObject CriteriaInner = new JSONObject();
				CriteriaInner.put("building", building);
				CriteriaInner.put("sign", sign);
				CriteriaInner.put("energy_type", energy_type);
				CriteriaInner.put("valid_time_from", price.get("valid_time_from"));
				JSONObject SetInner = new JSONObject();
				SetInner.put("valid_time_to", valid_time_from);
				QueryUtil.update(ConstantCE.database_name, "tenant_energy_price", CriteriaInner, SetInner);
				JSONObject InsertObject_price = new JSONObject();
				InsertObject_price.put("building", building);
				InsertObject_price.put("sign", sign);
				InsertObject_price.put("energy_type", energy_type);
				InsertObject_price.put("valid_time_from", valid_time_from);
				InsertObject_price.put("price_content", price_content);
				QueryUtil.insert(ConstantCE.database_name, "tenant_energy_price", InsertObject_price);
				break;// 多余
			} else {
				String priceNext_time = (String) priceNext.get("valid_time_from");
				if (priceNext_time.compareTo(valid_time_from) >= 0) {
					JSONObject CriteriaInner = new JSONObject();
					CriteriaInner.put("building", building);
					CriteriaInner.put("sign", sign);
					CriteriaInner.put("energy_type", energy_type);
					CriteriaInner.put("valid_time_from", price.get("valid_time_from"));
					JSONObject SetInner = new JSONObject();
					SetInner.put("valid_time_to", valid_time_from);
					QueryUtil.update(ConstantCE.database_name, "tenant_energy_price", CriteriaInner, SetInner);
					if (priceNext_time.compareTo(valid_time_from) == 0) {
						CriteriaInner = new JSONObject();
						CriteriaInner.put("building", building);
						CriteriaInner.put("sign", sign);
						CriteriaInner.put("energy_type", energy_type);
						CriteriaInner.put("valid_time_from", priceNext_time);
						SetInner = new JSONObject();
						SetInner.put("price_content", price_content);
						QueryUtil.update(ConstantCE.database_name, "tenant_energy_price", CriteriaInner, SetInner);
					} else {
						JSONObject InsertObject_price = new JSONObject();
						InsertObject_price.put("building", building);
						InsertObject_price.put("sign", sign);
						InsertObject_price.put("energy_type", energy_type);
						InsertObject_price.put("valid_time_from", valid_time_from);
						InsertObject_price.put("valid_time_to", priceNext_time);
						InsertObject_price.put("price_content", price_content);
						QueryUtil.insert(ConstantCE.database_name, "tenant_energy_price", InsertObject_price);
					}
					break;
				}
			}
		}
	}

	public static void ModifyTenantPrice_before(String building, String sign, String energy_type, String valid_time_from, String price_content)
			throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("sign", sign);
		Criteria.put("energy_type", energy_type);
		JSONArray Content = QueryUtil.select(ConstantCE.database_name, "tenant_energy_price", Criteria);
		for (int i = 0; i < Content.size(); i++) {
			JSONObject price = (JSONObject) Content.get(i);
			JSONObject priceNext = null;
			if (i < Content.size() - 1) {
				priceNext = (JSONObject) Content.get(i + 1);
			}
			if (priceNext == null) {
				JSONObject CriteriaInner = new JSONObject();
				CriteriaInner.put("building", building);
				CriteriaInner.put("sign", sign);
				CriteriaInner.put("energy_type", energy_type);
				CriteriaInner.put("valid_time_from", price.get("valid_time_from"));
				JSONObject SetInner = new JSONObject();
				SetInner.put("valid_time_to", valid_time_from);
				SetInner.put("price_content", price_content);
				QueryUtil.update(ConstantCE.database_name, "tenant_energy_price", CriteriaInner, SetInner);
				JSONObject InsertObject_price = new JSONObject();
				InsertObject_price.put("building", building);
				InsertObject_price.put("sign", sign);
				InsertObject_price.put("energy_type", energy_type);
				InsertObject_price.put("valid_time_from", valid_time_from);
				InsertObject_price.put("price_content", price.get("price_content"));
				QueryUtil.insert(ConstantCE.database_name, "tenant_energy_price", InsertObject_price);
				break;// 多余
			} else {
				String priceNext_time = (String) priceNext.get("valid_time_from");
				if (priceNext_time.compareTo(valid_time_from) >= 0) {
					JSONObject CriteriaInner = new JSONObject();
					CriteriaInner.put("building", building);
					CriteriaInner.put("sign", sign);
					CriteriaInner.put("energy_type", energy_type);
					CriteriaInner.put("valid_time_from", price.get("valid_time_from"));
					JSONObject SetInner = new JSONObject();
					SetInner.put("valid_time_to", valid_time_from);
					SetInner.put("price_content", price_content);
					QueryUtil.update(ConstantCE.database_name, "tenant_energy_price", CriteriaInner, SetInner);
					if (priceNext_time.compareTo(valid_time_from) == 0) {
					} else {
						JSONObject InsertObject_price = new JSONObject();
						InsertObject_price.put("building", building);
						InsertObject_price.put("sign", sign);
						InsertObject_price.put("energy_type", energy_type);
						InsertObject_price.put("valid_time_from", valid_time_from);
						InsertObject_price.put("valid_time_to", priceNext_time);
						InsertObject_price.put("price_content", price.get("price_content"));
						QueryUtil.insert(ConstantCE.database_name, "tenant_energy_price", InsertObject_price);
					}
					break;
				}
			}
		}
	}

	public static void RechargeTenant(String building, String sign, String operate_time, Double amount) throws Exception {
		JSONObject InsertObject = new JSONObject();
		InsertObject.put("building", building);
		InsertObject.put("sign", sign);
		InsertObject.put("energy_type", null);
		InsertObject.put("operate_time", operate_time);
		InsertObject.put("amount", amount);
		InsertObject.put("is_used", null);
		QueryUtil.insert(ConstantCE.database_name, "tenant_recharge", InsertObject);
	}

	public static void RechargeTenantEnergy(String building, String sign, String energy_type, String operate_time, Double amount) throws Exception {
		JSONObject InsertObject = new JSONObject();
		InsertObject.put("building", building);
		InsertObject.put("sign", sign);
		InsertObject.put("energy_type", energy_type);
		InsertObject.put("operate_time", operate_time);
		InsertObject.put("amount", amount);
		InsertObject.put("is_used", null);
		QueryUtil.insert(ConstantCE.database_name, "tenant_recharge", InsertObject);
	}
}
