package com.persagy.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.WSData;
import com.persagy.entity.WSData_fjd_2;
import com.persagy.entity.WSParam;
import com.persagy.util.ConstantWeb;
import com.persagy.util.QueryUtil;
import com.persagy.util.ZillionAgentUtil;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
public class ServiceUtil2 {

	public static WSData[] data_energy(String building, String energyModelSign, String energyModelNodeSign, String time_period, String data_time_from,
			String data_time_to) {
		try {
			building = "Bd" + building + "001";
			List<WSData> dataList_query = QueryUtil.GetDataEnergy(building, energyModelSign, energyModelNodeSign, time_period, data_time_from,
					data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static WSData[] data_service(String building, String meter, Long funcid, String time_period, String data_time_from, String data_time_to) {
		try {
			List<WSData> dataList_query = QueryUtil.GetDataService(building, meter, funcid, time_period, data_time_from, data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static WSData[] data_near(String building, String meter, Long funcid, String time_period, String data_time_from, String data_time_to) {
		try {
			List<WSData> dataList_query = QueryUtil.GetDataNear(building, meter, funcid, time_period, data_time_from, data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static WSData[] data_near_0(String building, String meter, Long funcid, String time_period, String data_time_from, String data_time_to) {
		try {
			List<WSData> dataList_query = QueryUtil.GetDataNear(0, building, meter, funcid, time_period, data_time_from, data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static WSData[] data_near_1(String building, String meter, Long funcid, String time_period, String data_time_from, String data_time_to) {
		try {
			List<WSData> dataList_query = QueryUtil.GetDataNear(1, building, meter, funcid, time_period, data_time_from, data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static WSData[] data_near_2(String building, String meter, Long funcid, String time_period, String data_time_from, String data_time_to) {
		try {
			List<WSData> dataList_query = QueryUtil.GetDataNear(2, building, meter, funcid, time_period, data_time_from, data_time_to);
			return dataList_query.toArray(new WSData[0]);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
		return null;
	}

	public static void write_fjd_2(WSParam param) {
		try {
			String fjd_i = "fjd_2";
			if (ConstantWeb.fjd_3) {
				fjd_i = "fjd_3";
			}
			SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
			String building = param.getBuilding();

			Long curround = null;
			{
				JSONObject Criteria = new JSONObject();
				Criteria.put("object_sign", building);
				Criteria.put("instance_name", fjd_i);
				JSONArray resultContent = ZillionAgentUtil.select("ce_curround", Criteria);
				if (resultContent.size() > 0) {
					JSONObject ce_curround = (JSONObject) resultContent.get(0);
					curround = (Long) ce_curround.get("compute_round");
				}
			}
			if (curround == null) {
				JSONObject Criteria = new JSONObject();
				Criteria.put("building", building);
				JSONArray resultContent = ZillionAgentUtil.select(fjd_i + "_computelog", Criteria);
				if (resultContent.size() > 0) {
					JSONObject dataItem = (JSONObject) resultContent.get(resultContent.size() - 1);
					curround = (Long) dataItem.get("compute_round");
				} else {
					curround = 0L;
				}
			}
			ZillionAgentUtil.Generate_round(building, fjd_i, curround + 1);

			long compute_round = curround + 1;
			String meter = param.getMeter();
			long funcid = param.getFuncid();
			WSData_fjd_2[] datas_fjd_2 = param.getDatas_fjd_2();
			String time_from = null;
			String time_to = null;
			time_from = datas_fjd_2[0].getData_time();
			time_to = datas_fjd_2[datas_fjd_2.length - 1].getData_time();

			String[] time_periods = { "15min", "1h", "1d" };
			for (String time_period : time_periods) {
				QueryUtil.delete_fjd(fjd_i + "_near", building, meter, funcid, time_period, time_from, time_to);
			}

			Map<String, JSONArray> biggerInsertObjectsMap = new HashMap<String, JSONArray>();
			JSONArray InsertObjects_near = new JSONArray();
			for (WSData_fjd_2 data : datas_fjd_2) {
				JSONObject InsertObject_near = new JSONObject();
				InsertObject_near.put("building", building);
				InsertObject_near.put("meter", meter);
				InsertObject_near.put("funcid", funcid);
				InsertObject_near.put("time_period", data.getTime_period());
				InsertObject_near.put("data_time", data.getData_time());
				InsertObject_near.put("data_flag", data.getData_flag());
				InsertObject_near.put("data_value", data.getData_value());
				InsertObjects_near.add(InsertObject_near);

				Date data_time = sdf.parse(data.getData_time());
				List<String> biggerList = QueryUtil.getBigger(data.getTime_period());
				for (int i = 0; i < biggerList.size(); i++) {
					String bigger = biggerList.get(i);
					if (QueryUtil.DateMatch(bigger, data_time)) {
						if (!biggerInsertObjectsMap.containsKey(bigger)) {
							biggerInsertObjectsMap.put(bigger, new JSONArray());
						}
						JSONObject InsertObject = new JSONObject();
						InsertObject.put("building", building);
						InsertObject.put("meter", meter);
						InsertObject.put("funcid", funcid);
						InsertObject.put("time_period", bigger);
						InsertObject.put("data_time", data.getData_time());
						InsertObject.put("data_flag", data.getData_flag());
						InsertObject.put("data_value", data.getData_value());
						biggerInsertObjectsMap.get(bigger).add(InsertObject);
					}
				}
			}

			for (String bigger : biggerInsertObjectsMap.keySet()) {
				JSONArray biggerInsertObjects = biggerInsertObjectsMap.get(bigger);
				if (biggerInsertObjects.size() > 0) {
					QueryUtil.batch_insert(fjd_i + "_near", biggerInsertObjects);
				}
			}
			if (InsertObjects_near.size() > 0) {
				QueryUtil.batch_insert(fjd_i + "_near", InsertObjects_near);
			}

			JSONObject InsertObject_detail = new JSONObject();
			InsertObject_detail.put("building", building);
			InsertObject_detail.put("compute_round", compute_round);
			InsertObject_detail.put("meter", meter);
			InsertObject_detail.put("funcid", funcid);
			InsertObject_detail.put("valid_time_from", time_from);
			InsertObject_detail.put("valid_time_to", time_to);
			InsertObject_detail.put("operate_time_to", sdf.format(new Date()));
			ZillionAgentUtil.insert(fjd_i + "_computedetail", InsertObject_detail);

			JSONObject InsertObject_log = new JSONObject();
			InsertObject_log.put("building", building);
			InsertObject_log.put("compute_round", compute_round);
			InsertObject_log.put("compute_time_from", time_from);
			InsertObject_log.put("compute_time_to", time_to);
			InsertObject_log.put("is_finished", 1L);
			InsertObject_log.put("operate_time_from", sdf.format(new Date()));
			InsertObject_log.put("operate_time_to", sdf.format(new Date()));
			ZillionAgentUtil.insert(fjd_i + "_computelog", InsertObject_log);
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		} finally {
		}
	}

	public static void present_building(WSParam param) {
		try {
			String building = param.getBuilding();
			param.setBuildingdatas(QueryUtil.GetBuildingdatas(building));
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}
	}

}
