package com.persagy.util;

import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.zillion.database.agent.IZillionAgent;
import com.zillion.database.agent.ZillionAgent;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.InputStream;
import java.util.Iterator;

import static com.sagacloud.util.compute_engine.util.ConstantCE.getStream;
@Slf4j
@SuppressWarnings("rawtypes")
public class ConstantAgent {

    public static String database_name;
    public static String Server_name;

    public static boolean objectdata_Service = false;

    public static ZillionAgent GetAgent() {
        return HBaseSaveManagerRepository.randomZillionAgent();
    }

    public static IZillionAgent GetIZillionAgent() {
        return HBaseSaveManagerRepository.randomZillionAgent();
    }

    static {
        try {
            try (InputStream stream = getStream("config.xml")) {
                SAXReader saxReader = new SAXReader();
                Document document = saxReader.read(stream);
                if (document != null) {
                    Iterator iter;
                    Element element;

                    iter = document.selectNodes("/root/database_name").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        database_name = element.getText();
                    }

                    iter = document.selectNodes("/root/AddressServer").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Server_name = element.attribute("name").getValue();
                    }
                }
            }
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
    }
}
