package com.persagy.util;

import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.core.util.StrUtil;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Attribute;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;
import org.zillion.util.log.LogUtil;

import java.io.File;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
@Slf4j
@SuppressWarnings("rawtypes")
public class ConstantWeb {
    public static String Server_name;
    public static boolean funcid_10101_to_0 = false;
    public static boolean EMS_use_collectsign = false;
    public static boolean old_saas_parallel = false;
    public static boolean recompute_metercomputetime = false;
    public static boolean reportpoint_fixed_period_enable = false;
    public static String reportpoint_fixed_period_value;

    public static boolean fjd_3 = false;

    public static Map<String, Long> name2interval = new HashMap<String, Long>();
    public static Map<String, String> name2status_request = new HashMap<String, String>();

    public static Map<String, String> BuildingUploadMap = new HashMap<String, String>();
    public static Map<String, Boolean> BuildingIncludesMap = new HashMap<String, Boolean>();
    public static Map<String, Boolean> BuildingExcludesMap = new HashMap<String, Boolean>();

    public static Map<String, Boolean> zongzhi_ignore_serviceTypeMap = new HashMap<String, Boolean>();

    static {
        try {
            try (InputStream stream = getStream("config.xml")) {
                SAXReader saxReader = new SAXReader();
                Document document = saxReader.read(stream);
                if (document != null) {
                    Iterator iter;
                    Element element;

                    iter = document.selectNodes("/root/Server").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        Server_name = element.attribute("name").getValue();
                    }

                    iter = document.selectNodes("/root/funcid_10101_to_0").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        funcid_10101_to_0 = element.getText().equalsIgnoreCase("true") ? true : false;
                    }

                    iter = document.selectNodes("/root/EMS_use_collectsign").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        EMS_use_collectsign = element.getText().equalsIgnoreCase("true") ? true : false;
                    }

                    iter = document.selectNodes("/root/old_saas_parallel").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        old_saas_parallel = element.getText().equalsIgnoreCase("true") ? true : false;
                    }

                    iter = document.selectNodes("/root/recompute_metercomputetime").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        recompute_metercomputetime = element.getText().equalsIgnoreCase("true") ? true : false;
                    }

                    iter = document.selectNodes("/root/reportpoint_fixed_period").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        reportpoint_fixed_period_enable = element.attribute("enable").getValue().equalsIgnoreCase("true") ? true : false;
                        reportpoint_fixed_period_value = element.attribute("value").getValue();
                    }

                    iter = document.selectNodes("/root/fjd_3").iterator();
                    if (iter.hasNext()) {
                        element = (Element) iter.next();
                        fjd_3 = element.getText().equalsIgnoreCase("true") ? true : false;
                    }

                    iter = document.selectNodes("/root/compute").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        String name = element.attribute("name").getValue();
                        long interval = Long.parseLong(element.attribute("interval").getValue());
                        String status_request = element.attribute("status_request").getValue();
                        name2interval.put(name, interval);
                        name2status_request.put(name, status_request);
                    }

                    iter = document.selectNodes("/root/BuildingIncludes/Building").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        String sign = element.attribute("sign").getValue();
                        Attribute sign_new = element.attribute("sign_new");
                        if (sign_new != null) {
                            BuildingUploadMap.put(sign, sign_new.getValue());
                            BuildingIncludesMap.put(sign_new.getValue(), true);
                        } else {
                            BuildingUploadMap.put(sign, sign);
                            BuildingIncludesMap.put(sign, true);
                        }
                    }

                    iter = document.selectNodes("/root/BuildingExcludes/Building").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        BuildingExcludesMap.put(element.getText(), true);
                    }

                    iter = document.selectNodes("/root/zongzhi_ignore_serviceType").iterator();
                    while (iter.hasNext()) {
                        element = (Element) iter.next();
                        zongzhi_ignore_serviceTypeMap.put(element.getText(), true);
                    }

                }
            }
        } catch (Exception e) {
            log.error(e.getMessage(),e);
        }
    }

    public static InputStream getStream(String resourc) {
        if (resourc.startsWith(File.separator)) {
            resourc = StrUtil.removePrefix(resourc, File.separator);
        }
        try {
            String filePath = File.separator + "usr" + File.separator + "local" + File.separator + "etc" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                LogUtil.warn("getStream success 0" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级config目录
            String filePath = System.getProperty("user.dir") + File.separator + "config" + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                LogUtil.warn("getStream success 1" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // jar包同级目录
            String filePath = System.getProperty("user.dir") + File.separator + resourc;
            InputStream stream = ResourceUtil.getStream(filePath);
            if (stream != null) {
                LogUtil.warn("getStream success 2" + "\t" + filePath);
                return stream;
            }
        } catch (Exception e) {
        }
        try {
            // ClassPath目录
            InputStream in = new org.springframework.core.io.ClassPathResource(File.separator + resourc).getInputStream();
            if (in != null) {
                LogUtil.warn("getStream success 3" + "\t" + "ClassPathResource" + "\t" + resourc);
                return in;
            }
        } catch (Exception e) {
        }
        try {
            InputStream stream = ConstantWeb.class.getResourceAsStream(File.separator + resourc);
            if (stream != null) {
                LogUtil.warn("getStream success 4" + "\t" + "getResourceAsStream" + "\t" + resourc);
                return stream;
            }
        } catch (Exception e) {
        }
        LogUtil.warn("getStream fail " + resourc);
        return null;
    }
}
