package com.persagy.util;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.EntityDynamicData;
import com.persagy.entity.EntityDynamicDataArray;
import com.sagacloud.util.compute_engine.util.DoubleTimeObject;

public class DynamicDataUtil {
	public static EntityDynamicData Convert_original(JSONObject json) {
		if (json == null) {
			return null;
		}

		EntityDynamicData result = new EntityDynamicData();
		result.setTime(json.getString("receivetime"));
		result.setValue(json.getDouble("data"));
		return result;
	}

	public static EntityDynamicData Convert(JSONObject json) {
		if (json == null) {
			return null;
		}

		EntityDynamicData result = new EntityDynamicData();
		result.setTime(json.getString("data_time"));
		result.setValue(json.getDouble("data_value"));
		return result;
	}

	public static EntityDynamicDataArray ConvertArray_original(JSONArray Content) {
		if (Content == null) {
			return null;
		}

		EntityDynamicDataArray result = new EntityDynamicDataArray();
		List<EntityDynamicData> dataList = new ArrayList<EntityDynamicData>();
		for (int i = 0; i < Content.size(); i++) {
			EntityDynamicData data = Convert_original(Content.getJSONObject(i));
			dataList.add(data);
		}
		result.setDataArray(dataList.toArray(new EntityDynamicData[0]));
		return result;
	}

	public static EntityDynamicDataArray ConvertArray(JSONArray Content) {
		if (Content == null) {
			return null;
		}

		EntityDynamicDataArray result = new EntityDynamicDataArray();
		List<EntityDynamicData> dataList = new ArrayList<EntityDynamicData>();
		for (int i = 0; i < Content.size(); i++) {
			EntityDynamicData data = Convert(Content.getJSONObject(i));
			dataList.add(data);
		}
		result.setDataArray(dataList.toArray(new EntityDynamicData[0]));
		return result;
	}

	public static EntityDynamicData Convert(DoubleTimeObject dto) {
		if (dto == null) {
			return null;
		}

		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
		EntityDynamicData result = new EntityDynamicData();
		result.setTime(sdf.format(dto.data_time));
		result.setValue(dto.data_value);
		return result;
	}

	public static EntityDynamicDataArray ConvertArray(List<DoubleTimeObject> dtoList) {
		if (dtoList == null) {
			return null;
		}

		EntityDynamicDataArray result = new EntityDynamicDataArray();
		List<EntityDynamicData> dataList = new ArrayList<EntityDynamicData>();
		for (int i = 0; i < dtoList.size(); i++) {
			EntityDynamicData data = Convert(dtoList.get(i));
			dataList.add(data);
		}
		result.setDataArray(dataList.toArray(new EntityDynamicData[0]));
		return result;
	}
}
