package com.persagy.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.entity.WSBuildingData;
import com.persagy.entity.WSData;
import com.persagy.entity.WSFlag;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.*;
@Slf4j
public class QueryUtil {
	public static boolean DateMatch(String time_period, Date data_time) {
		boolean result = false;

		long data_time_long = data_time.getTime();
		if (time_period.equals("5min")) {
			if (data_time_long % (1000L * 60 * 5) == 0) {
				result = true;
			}
		} else if (time_period.equals("10min")) {
			if (data_time_long % (1000L * 60 * 10) == 0) {
				result = true;
			}
		} else if (time_period.equals("15min")) {
			if (data_time_long % (1000L * 60 * 15) == 0) {
				result = true;
			}
		} else if (time_period.equals("1h")) {
			if (data_time_long % (1000L * 60 * 60) == 0) {
				result = true;
			}
		} else if (time_period.equals("1d")) {
			if ((data_time_long + 1000L * 60 * 60 * 8) % (1000L * 60 * 60 * 24) == 0) {
				result = true;
			}
		}

		return result;
	}

	public static List<String> getBigger(String collect_cycle) throws Exception {
		List<String> bigger_collect_cycle = new ArrayList<String>();
		if (collect_cycle.equals("1min")) {
			bigger_collect_cycle.add("5min");
			bigger_collect_cycle.add("15min");
			bigger_collect_cycle.add("1h");
			bigger_collect_cycle.add("1d");
		} else if (collect_cycle.equals("5min")) {
			bigger_collect_cycle.add("15min");
			bigger_collect_cycle.add("1h");
			bigger_collect_cycle.add("1d");
		} else if (collect_cycle.equals("10min")) {
			bigger_collect_cycle.add("1h");
			bigger_collect_cycle.add("1d");
		} else if (collect_cycle.equals("15min")) {
			bigger_collect_cycle.add("1h");
			bigger_collect_cycle.add("1d");
		} else if (collect_cycle.equals("1h")) {
			bigger_collect_cycle.add("1d");
		} else {
			throw new Exception("collect_cycle error:" + collect_cycle);
		}
		return bigger_collect_cycle;
	}

	public static List<WSData> GetDataService(String building, String meter, Long funcid, String time_period, String data_time_from,
			String data_time_to) throws Exception {
		List<WSData> result = new ArrayList<WSData>();
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject range = new JSONObject();
		range.put("$gte", data_time_from);
		range.put("$lte", data_time_to);
		Criteria.put("data_time", range);
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "data_servicedata" + "_" + time_period);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		for (int i = 0; i < resultContent.size(); i++) {
			JSONObject dataItem = (JSONObject) resultContent.get(i);
			WSData data = new WSData();
			data.setData_time((String) dataItem.get("data_time"));
			data.setData_value((Double) (dataItem.get("data_value")));
			result.add(data);
		}
		return result;
	}

	public static List<WSData> GetDataEnergy(String building, String energyModelSign, String energyModelNodeSign, String time_period,
			String data_time_from, String data_time_to) throws Exception {
		List<WSData> result = new ArrayList<WSData>();
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("energyModelSign", energyModelSign);
		Criteria.put("energyModelNodeSign", energyModelNodeSign);
		JSONObject range = new JSONObject();
		range.put("$gte", data_time_from);
		range.put("$lte", data_time_to);
		Criteria.put("data_time", range);
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "data_energydata" + "_" + time_period);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		for (int i = 0; i < resultContent.size(); i++) {
			JSONObject dataItem = (JSONObject) resultContent.get(i);
			WSData data = new WSData();
			data.setData_time((String) dataItem.get("data_time"));
			data.setData_value((Double) (dataItem.get("data_value")));
			result.add(data);
		}
		return result;
	}

	public static List<WSData> GetDataNear(String building, String meter, long funcid, String time_period, String data_time_from, String data_time_to)
			throws Exception {
		SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
		List<WSData> result = new ArrayList<WSData>();

		Map<String, Boolean> tableMap = new HashMap<String, Boolean>();
		{
			JSONObject wrapperObject = new JSONObject();
			wrapperObject.put("QueryType", "table_list_strict");
			wrapperObject.put("Database", ConstantCE.database_name);
			JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
			JSONArray table_list = (JSONArray) queryResult.get("Content");
			for (int i = 0; i < table_list.size(); i++) {
				String table = (String) table_list.get(i);
				tableMap.put(table, true);
			}
		}

		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject range = new JSONObject();
		range.put("$gte", data_time_from);
		range.put("$lte", data_time_to);
		Criteria.put("data_time", range);

		int fjd_count = 4;
		JSONArray[] resultContentArray = new JSONArray[fjd_count];
		int[] indexTmp = new int[4];
		for (int i = 0; i < fjd_count; i++) {
			String table = "fjd_" + i + "_near" + "_" + time_period;
			if (tableMap.containsKey(table)) {
				JSONObject wrapperObject = new JSONObject();
				wrapperObject.put("QueryType", "select");
				wrapperObject.put("Database", ConstantCE.database_name);
				wrapperObject.put("Datatable", table);
				wrapperObject.put("Criteria", Criteria);
				JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
				resultContentArray[i] = (JSONArray) queryResult.get("Content");
			} else {
				resultContentArray[i] = new JSONArray();
			}
			indexTmp[i] = 0;
		}

		Date time_from = sdf.parse(data_time_from);
		Date time_to = sdf.parse(data_time_to);
		Date timeTmp = time_from;
		long interval = get_interval(time_period);
		while (timeTmp.getTime() <= time_to.getTime()) {
			WSData[] entityArray = new WSData[4];
			for (int i = 0; i < fjd_count; i++) {
				JSONArray resultContent = resultContentArray[i];
				for (int ii = indexTmp[i]; ii < resultContent.size(); ii++) {
					indexTmp[i] = ii;
					JSONObject dataItem = (JSONObject) resultContent.get(ii);
					Date data_time = sdf.parse((String) dataItem.get("data_time"));
					if (data_time.getTime() < timeTmp.getTime()) {
					} else if (data_time.getTime() == timeTmp.getTime()) {
						WSData entity = new WSData();
						entity.setData_from("" + i);
						entity.setData_time((String) dataItem.get("data_time"));
						entity.setLabel_flag(dataItem.get("data_flag").toString());
						entity.setData_value(dataItem.get("data_value") == null ? null : (Double) dataItem.get("data_value"));
						entityArray[i] = entity;
					} else {
						break;
					}
				}
			}

			WSData entity = null;
			for (int i = fjd_count - 1; i >= 0; i--) {
				if (entityArray[i] != null) {
					entity = entityArray[i];
					break;
				}
			}
			if (entity != null) {
				result.add(entity);
			}

			timeTmp = new Date(timeTmp.getTime() + interval);
		}

		return result;
	}

	public static long get_interval(String time_period) {
		long result = 0L;
		if (time_period.equals("1min")) {
			result = 1000L * 60;
		} else if (time_period.equals("5min")) {
			result = 1000L * 60 * 5;
		} else if (time_period.equals("10min")) {
			result = 1000L * 60 * 10;
		} else if (time_period.equals("15min")) {
			result = 1000L * 60 * 15;
		} else if (time_period.equals("1h")) {
			result = 1000L * 60 * 60;
		} else if (time_period.equals("1d")) {
			result = 1000L * 60 * 60 * 24;
		}
		return result;
	}

	public static String GetMeterFirstTime(String building, String meter, long funcid) throws Exception {

		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);

		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "fjd_0_metercomputetime");
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		if (resultContent.size() > 0) {
			JSONObject dataItem = (JSONObject) resultContent.get(0);
			return (String) dataItem.get("first_compute_time");
		}

		return null;
	}

	public static List<WSData> GetDataNear(int fjd_i, String building, String meter, long funcid, String time_period, String data_time_from,
			String data_time_to) throws Exception {
		List<WSData> result = new ArrayList<WSData>();

		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject range = new JSONObject();
		range.put("$gte", data_time_from);
		range.put("$lte", data_time_to);
		Criteria.put("data_time", range);
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "fjd_" + fjd_i + "_near" + "_" + time_period);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		for (int i = 0; i < resultContent.size(); i++) {
			JSONObject dataItem = (JSONObject) resultContent.get(i);
			WSData data = new WSData();
			String data_time = (String) dataItem.get("data_time");
			data.setData_from("" + fjd_i);
			data.setData_time(data_time);
			data.setLabel_flag(dataItem.get("data_flag").toString());
			data.setData_value((Double) dataItem.get("data_value"));
			result.add(data);
		}

		return result;
	}

	public static List<WSFlag> GetFlagNear(String building, String meter, long funcid, String time_period, String data_time_from, String data_time_to)
			throws Exception {
		List<WSFlag> result = new ArrayList<WSFlag>();

		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		JSONObject range = new JSONObject();
		range.put("$gte", data_time_from);
		range.put("$lte", data_time_to);
		Criteria.put("data_time", range);
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "fjd_flag_near" + "_" + time_period);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		for (int i = 0; i < resultContent.size(); i++) {
			JSONObject dataItem = (JSONObject) resultContent.get(i);
			WSFlag data = new WSFlag();
			data.setData_time((String) dataItem.get("data_time"));
			data.setRely_flag((Long) dataItem.get("rely_flag"));
			result.add(data);
		}

		return result;
	}

	public static WSBuildingData[] GetBuildingdatas(String building) {
		WSBuildingData[] buildingdatas = null;

		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);

		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", "original_present");
		wrapperObject.put("Criteria", Criteria);
		try {
			JSONObject queryResult;
			queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
			JSONArray resultContent = (JSONArray) queryResult.get("Content");
			log.info(building + ".size: " + resultContent.size());
			if (resultContent.size() > 0) {
				buildingdatas = new WSBuildingData[resultContent.size()];
				for (int i = 0; i < resultContent.size(); i++) {
					JSONObject dataItem = (JSONObject) resultContent.get(i);

					WSBuildingData buildingdata = new WSBuildingData();
					buildingdata.setMeter((String) dataItem.get("meter"));
					buildingdata.setFuncid((Long) dataItem.get("funcid"));
					buildingdata.setData_time((String) dataItem.get("receivetime"));
					buildingdata.setData_value((Double) dataItem.get("data"));

					buildingdatas[i] = buildingdata;
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage(),e);
		}

		return buildingdatas;
	}

	public static void delete_fjd(String table_name, String building, String meter, long funcid, String time_period, String time_from, String time_to)
			throws Exception {
		delete_fjd(true, table_name, building, meter, funcid, time_period, time_from, time_to);
	}

	public static void batch_insert(String table_name, JSONArray InsertObjects) throws Exception {
		batch_insert(true, table_name, InsertObjects);
	}

	private static void delete_fjd(boolean time_period_seperate, String table_name, String building, String meter, long funcid, String time_period,
			String time_from, String time_to) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("building", building);
		Criteria.put("meter", meter);
		Criteria.put("funcid", funcid);
		if (time_period_seperate) {
			//
		} else {
			Criteria.put("time_period", time_period);
		}
		JSONObject range = new JSONObject();
		range.put("$gte", time_from);
		range.put("$lte", time_to);
		Criteria.put("data_time", range);
		if (time_period_seperate) {
			ZillionAgentUtil.delete(table_name + "_" + time_period, Criteria);
		} else {
			ZillionAgentUtil.delete(table_name, Criteria);
		}
	}

	private static void batch_insert(boolean time_period_seperate, String table_name, JSONArray InsertObjects) throws Exception {
		if (time_period_seperate) {
			Map<String, JSONArray> InsertObjectsMap = new HashMap<String, JSONArray>();
			for (int i = 0; i < InsertObjects.size(); i++) {
				JSONObject InsertObject = (JSONObject) InsertObjects.get(i);
				String time_period = (String) InsertObject.get("time_period");
				InsertObject.remove("time_period");
				if (!InsertObjectsMap.containsKey(time_period)) {
					InsertObjectsMap.put(time_period, new JSONArray());
				}
				JSONArray InsertObjectsInner = InsertObjectsMap.get(time_period);
				InsertObjectsInner.add(InsertObject);
			}
			Iterator<String> keyIter = InsertObjectsMap.keySet().iterator();
			while (keyIter.hasNext()) {
				String time_period = keyIter.next();
				JSONArray InsertObjectsInner = InsertObjectsMap.get(time_period);
				ZillionAgentUtil.batch_insert(table_name + "_" + time_period, InsertObjectsInner);
			}
		} else {
			ZillionAgentUtil.batch_insert(table_name, InsertObjects);
		}
	}
}
