package com.persagy.util;

import cn.hutool.core.io.resource.ResourceUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONReader;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import org.zillion.util.json.FastJsonUtil;

public class TableUtil {
    static String[] table_names = {"dy_pointlist", "fjd_0_buildingcomputetime", "fjd_0_compute_request", "fjd_0_metercomputetime", "ci_instance",
            "ci_instanceinput", "ci_instanceoutput", "ci_status", "dy_reportpointlist", "originalreport_data", "originalreport_change_meter",
            "originalreport_log", "originalreport_round", "tenant", "tenant_recharge", "tenant_energy", "tenant_energy_meter",
            "tenant_energy_price"};

    public static void AddTables( String database_name) throws Exception {
        for (String table_name : table_names) {
            AddTable( database_name, table_name);
        }
    }

    public static void AddTable( String database_name, String table_name) throws Exception {
        JSONReader json_reader = new JSONReader(ResourceUtil.getUtf8Reader("def_" + table_name + ".json"));
        Object result = json_reader.readObject();
        FastJsonUtil.Normalize(result);
        JSONObject def = (JSONObject) result;

        JSONArray Columns = (JSONArray) def.get("Columns");
        JSONArray Key = (JSONArray) def.get("Key");
        JSONObject table_schema = new JSONObject();
        table_schema.put("Columns", Columns);
        table_schema.put("Key", Key);
        try {
            HBaseSaveManagerRepository.randomZillionAgent().DDL_AddTable(database_name, table_name, table_schema, (JSONArray) def.get("Indexes"));
        } catch (Exception e) {
            // log.error(e.getMessage(),e);
        }
    }

    public static void ClearTables( String database_name, boolean is_clear) throws Exception {
        for (String table_name : table_names) {
            QueryUtil.ClearTable(database_name, table_name, is_clear);
        }
    }

    public static void AlterTables( String database_name) throws Exception {
        String[] logs = {"originalreport_log"};
        JSONArray Columns_add = new JSONArray();
        {
            JSONObject Column = new JSONObject();
            Column.put("Name", "data_type");
            Column.put("Type", "String(20)");
            Columns_add.add(Column);
        }
        {
            JSONObject Column = new JSONObject();
            Column.put("Name", "time_from");
            Column.put("Type", "String(20)");
            Columns_add.add(Column);
        }
        {
            JSONObject Column = new JSONObject();
            Column.put("Name", "time_to");
            Column.put("Type", "String(20)");
            Columns_add.add(Column);
        }
        {
            JSONObject Column = new JSONObject();
            Column.put("Name", "operate_time");
            Column.put("Type", "String(20)");
            Columns_add.add(Column);
        }
        {
            JSONObject Column = new JSONObject();
            Column.put("Name", "data");
            Column.put("Type", "Double");
            Columns_add.add(Column);
        }
        JSONObject alter_content = new JSONObject();
        alter_content.put("Columns_add", Columns_add);
        for (String table_name : logs) {
            try {
                HBaseSaveManagerRepository.randomZillionAgent().DDL_AlterTable(database_name, table_name, "Columns_add", alter_content);
            } catch (Exception e) {
                if (e.getMessage().contains("Columns exist:")) {
                } else {
                    throw e;
                }
            }
        }
    }
}
