package com.persagy.util;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.util.ConstantCE;

public class ZillionAgentUtil {
	public static void Generate_round(String object_sign, String instance_name, Long round_new) throws Exception {
		JSONObject Criteria = new JSONObject();
		Criteria.put("object_sign", object_sign);
		Criteria.put("instance_name", instance_name);
		JSONArray resultContent = select("ce_curround", Criteria);
		long compute_round;
		if (round_new == null) {
			long exist = 0;
			if (resultContent.size() > 0) {
				JSONObject roundmax = (JSONObject) resultContent.get(0);
				exist = (Long) roundmax.get("compute_round");
			}
			compute_round = exist + 1;
		} else {
			compute_round = round_new;
		}

		if (resultContent.size() > 0) {
			JSONObject Set = new JSONObject();
			Set.put("compute_round", compute_round);
			update("ce_curround", Criteria, Set);
		} else {
			JSONObject InsertObject = new JSONObject();
			InsertObject.put("object_sign", object_sign);
			InsertObject.put("instance_name", instance_name);
			InsertObject.put("compute_round", compute_round);
			insert("ce_curround", InsertObject);
		}
	}

	public static JSONArray select(String table_name, JSONObject Criteria) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "select");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("Criteria", Criteria);
		JSONObject queryResult = HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
		JSONArray resultContent = (JSONArray) queryResult.get("Content");
		return resultContent;
	}

	public static void insert(String table_name, JSONObject InsertObject) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "insert");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("InsertObject", InsertObject);
		HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
	}

	public static void batch_insert(String table_name, JSONArray InsertObjects) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "batch_insert");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("InsertObjects", InsertObjects);
		HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
	}

	public static void update(String table_name, JSONObject Criteria, JSONObject Set) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "update");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("Criteria", Criteria);
		wrapperObject.put("Set", Set);
		HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
	}

	public static void delete(String table_name, JSONObject Criteria) throws Exception {
		JSONObject wrapperObject = new JSONObject();
		wrapperObject.put("QueryType", "delete");
		wrapperObject.put("Database", ConstantCE.database_name);
		wrapperObject.put("Datatable", table_name);
		wrapperObject.put("Criteria", Criteria);
		HBaseSaveManagerRepository.randomZillionAgent().Query(wrapperObject);
	}

}
