package com.persagy.util;

import java.util.List;

import org.apache.zookeeper.data.Stat;

import com.zillion.util.zk.ZKWrapper;

public class ZooKeeperUtil {

	public static void recursive(ZKWrapper zk, String path) throws Exception {
		Stat stat = zk.exists(path, false);
		if (stat == null) {
			return;
		}

		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}

		zk.delete(path, -1);
	}

	public static void recursiveChildren(ZKWrapper zk, String path) throws Exception {
		List<String> children = zk.getChildren(path, false);
		for (String child : children) {
			String parentPath = path.length() == 1 ? "/" : path + "/";
			String childPath = parentPath + child;

			recursive(zk, childPath);
		}
	}
}
