package com.sagacloud.init;

import cn.hutool.core.thread.ThreadUtil;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.persagy.service.ServiceUtil;
import com.persagy.util.ConstantWeb;
import com.persagy.util.TableUtil;
import com.persagy.util.ZooKeeperUtil;
import com.sagacloud.repository.HBaseSaveManagerRepository;
import com.sagacloud.util.compute_engine.entity.*;
import com.sagacloud.util.compute_engine.util.ConstantCE;
import com.sagacloud.util.compute_engine.util.InstanceUtil;
import com.sagacloud.util.compute_engine.util.QueryUtil;
import com.zillion.util.common.ZillionConstant;
import com.zillion.util.zk.ZKWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.data.Stat;
import org.zillion.util.json.FastJsonUtil;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
public class StartupThread implements Runnable {

    public StartupThread() {
    }


    @Override
    public void run() {
        ZillionConstant.ObserverWait = 0L;
        // util中用到以下设置
        ConstantCE.time_period_seperate = true;
        try {
            if (!QueryUtil.database_exist(ConstantCE.database_name)) {
                HBaseSaveManagerRepository.randomZillionAgent().NDL_AddDatabase(ConstantCE.database_name);
            }
            TableUtil.AddTables(ConstantCE.database_name);
            ThreadUtil.safeSleep(10 * 1000);
            TableUtil.AlterTables(ConstantCE.database_name);
            ZKWrapper ZK = HBaseSaveManagerRepository.randomZillionAgent().container.ZK;
            Stat stat = ZK.exists(ConstantCE.zk_initbegin, false);
            if (stat != null) {
                stat = ZK.exists(ConstantCE.zk_initend, false);
                if (stat == null) {
                    ZooKeeperUtil.recursive(ZK, ConstantCE.compute_engine);
                }
            }

            this.Initialize_load();

            while (true) {
                try {
                    this.Initialize_ci_shell();
                } catch (Exception e1) {
                    log.error(e1.getMessage(), e1);
                }
                ThreadUtil.safeSleep(1000L * 60);
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }

    private void Initialize_load() throws Exception {
        ZKWrapper ZK = HBaseSaveManagerRepository.randomZillionAgent().container.ZK;
        Stat stat = ZK.exists(ConstantCE.compute_engine, false);
        if (stat == null) {
            try {
                ZK.create(ConstantCE.compute_engine, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
            } catch (Exception e) {
                // log.error(e.getMessage(),e);
            }
        }
        stat = ZK.exists(ConstantCE.zk_root, false);
        if (stat == null) {
            try {
                ZK.create(ConstantCE.zk_root, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
            } catch (Exception e) {
                // log.error(e.getMessage(),e);
            }
        }

        String status = "begin";
        while (true) {
            ThreadUtil.safeSleep(1L);

            if (status.equals("begin")) {
                stat = ZK.exists(ConstantCE.zk_initbegin, false);
                if (stat != null) {
                    status = "check_begin_Y";
                } else {
                    status = "check_begin_N";
                }
            } else if (status.equals("check_begin_Y")) {
                stat = ZK.exists(ConstantCE.zk_initend, false);
                if (stat != null) {
                    status = "check_end_Y";
                } else {
                    status = "check_end_N";
                }
            } else if (status.equals("check_begin_N")) {
                try {// 尝试创建begin节点
                    ZK.create(ConstantCE.zk_initbegin, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                    status = "process";
                } catch (Exception e) {
                    // log.error(e.getMessage(),e);
                    status = "begin";
                }
            } else if (status.equals("check_end_Y")) {
                status = "ready";
            } else if (status.equals("check_end_N")) {
                status = "check_begin_Y";
            } else if (status.equals("process")) {
                ZK.create(ConstantCE.zk_instance, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_status, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_status_request, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_status_current, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_lock, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_compute_interval, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                ZK.create(ConstantCE.zk_compute_time_last, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                log.warn("zookeeper:" + ConstantCE.zk_root + " begin");
                log.warn("zookeeper:" + ConstantCE.zk_root + " GetAll begin");
                Entity_ci_instances instances = InstanceUtil.GetAll(ConstantCE.database_name);
                log.warn("zookeeper:" + ConstantCE.zk_root + " GetAll end");
                log.warn("zookeeper:" + ConstantCE.zk_root + " GetList_status begin");
                List<Entity_ci_status> statusList_query = InstanceUtil.GetList_status(ConstantCE.database_name);
                log.warn("zookeeper:" + ConstantCE.zk_root + " GetList_status end");

                List<Entity_ci_instance> instanceList = new ArrayList<Entity_ci_instance>();
                for (Entity_ci_instance instance : instances.getInstances()) {
                    if ((ConstantWeb.BuildingIncludesMap.size() > 0 && !ConstantWeb.BuildingIncludesMap.containsKey(instance.getObject_sign()))
                            || ConstantWeb.BuildingExcludesMap.containsKey(instance.getObject_sign())) {
                        continue;
                    }

                    instanceList.add(instance);
                }
                List<Entity_ci_status> statusList = new ArrayList<Entity_ci_status>();
                for (Entity_ci_status ci_status : statusList_query) {
                    if ((ConstantWeb.BuildingIncludesMap.size() > 0 && !ConstantWeb.BuildingIncludesMap.containsKey(ci_status.getObject_sign()))
                            || ConstantWeb.BuildingExcludesMap.containsKey(ci_status.getObject_sign())) {
                        continue;
                    }

                    statusList.add(ci_status);
                }

                log.warn("zookeeper:" + ConstantCE.zk_instance + " 0/" + instanceList.size());
                int instance_mod = instanceList.size() / 10 == 0 ? 1 : instanceList.size() / 10;
                for (int i = 0; i < instanceList.size(); i++) {
                    Entity_ci_instance ttt = instanceList.get(i);
                    Entity_ci_instance instance = InstanceUtil.Get(ConstantCE.database_name, ttt.getObject_sign(),
                            ttt.getInstance_name());

                    String name = instance.getObject_sign() + "_" + instance.getInstance_name();
                    JSONObject instanceJSON = (JSONObject) FastJsonUtil.To_JSON(instance);
                    ZK.create(ConstantCE.zk_instance + "/" + name, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                    long compute_interval_seconds = (Long) instanceJSON.get("compute_interval_seconds");
                    ZK.create(ConstantCE.zk_compute_interval + "/" + name, ("" + compute_interval_seconds).getBytes("UTF-8"), CreateMode.PERSISTENT);
                    if ((i + 1) % instance_mod == 0) {
                        log.warn("zookeeper:" + ConstantCE.zk_instance + " " + (i + 1) + "/" + instanceList.size());
                    }
                }
                log.warn("zookeeper:" + ConstantCE.zk_instance + " " + instanceList.size() + "/" + instanceList.size());

                log.warn("zookeeper:" + ConstantCE.zk_status_request + " " + 0 + "/" + instanceList.size());
                int statusList_mod = statusList.size() / 10 == 0 ? 1 : statusList.size() / 10;
                for (int i = 0; i < statusList.size(); i++) {
                    Entity_ci_status ci_status = statusList.get(i);

                    String name = ci_status.getObject_sign() + "_" + ci_status.getInstance_name();
                    ZK.create(ConstantCE.zk_status_request + "/" + name, ci_status.getStatus_request().getBytes("UTF-8"), CreateMode.PERSISTENT);
                    if ((i + 1) % statusList_mod == 0) {
                        log.warn("zookeeper:" + ConstantCE.zk_status_request + " " + (i + 1) + "/" + instanceList.size());
                    }
                }
                log.warn("zookeeper:" + ConstantCE.zk_status_request + " " + instanceList.size() + "/" + instanceList.size());
                log.warn("zookeeper:" + ConstantCE.zk_root + " end");

                ZK.create(ConstantCE.zk_initend, "true".getBytes("UTF-8"), CreateMode.PERSISTENT);
                status = "ready";
            } else if (status.equals("ready")) {
                break;
            }
        }
    }

    private void Initialize_ci_shell() throws Exception {
        if (!QueryUtil.table_exist(ConstantCE.database_name, "fjd_0_buildingcomputetime")) {
            return;
        }
        String[] instanceArray_1 = {"fjd_0_Acc_Inst_EnumV", "stat_Inst", "servicedata", "servicedata_max"};
        String[] instanceArray_2 = {"fjd_0_Acc_Inst_EnumV", "stat_Inst"};

        Map<String, Boolean> buildingMap = new HashMap<String, Boolean>();
        JSONObject Criteria = new JSONObject();
        JSONArray content = new JSONArray();
        if (QueryUtil.table_exist(ConstantCE.database_name, "fjd_0_buildingcomputetime")) {
            JSONArray content1 = QueryUtil.select(ConstantCE.database_name, "fjd_0_buildingcomputetime", Criteria);
            content.addAll(content1);
        }
        for (int i = 0; i < content.size(); i++) {
            JSONObject json = (JSONObject) content.get(i);
            String building = (String) json.get("building");
            if ((ConstantWeb.BuildingIncludesMap.size() > 0 && !ConstantWeb.BuildingIncludesMap.containsKey(building))
                    || ConstantWeb.BuildingExcludesMap.containsKey(building)) {
                continue;
            }
            if (buildingMap.containsKey(building)) {
                continue;
            }

            buildingMap.put(building, true);
            String[] instanceArray;
            if (ConstantCE.servicedata_use_survey) {
                instanceArray = instanceArray_2;
            } else {
                instanceArray = instanceArray_1;
            }
            for (String instance_name : instanceArray) {
                if (ConstantWeb.name2interval.containsKey(instance_name)) {
                    this.Initialize_ci_shell_one(building, instance_name);
                }
            }
        }
    }

    private void Initialize_ci_shell_one(String object_sign, String instance_name) throws Exception {
        Entity_ci_instance ci_instance = InstanceUtil.Get(ConstantCE.database_name, object_sign, instance_name);
        if (ci_instance == null) {
            ci_instance = new Entity_ci_instance();
            ci_instance.setObject_sign(object_sign);
            ci_instance.setInstance_name(instance_name);
            ci_instance.setFlag_valid(1L);
            ci_instance.setCompute_interval_seconds(ConstantWeb.name2interval.get(instance_name));
            ci_instance.setInputs(new Entity_ci_instanceinput[0]);
            ci_instance.setOutputs(new Entity_ci_instanceoutput[0]);
        }
        ServiceUtil.ci_instance_Update(ci_instance);
    }
}
