package com.persagy.service;

import cn.hutool.core.io.resource.ResourceUtil;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.JSONReader;
import com.persagy.wsentity.SSurvey;
import com.persagy.wsentity.SSurveyResult;
import org.apache.cxf.aegis.databinding.AegisDatabinding;
import org.apache.cxf.frontend.ClientProxyFactoryBean;
import org.apache.cxf.jaxws.support.JaxWsServiceFactoryBean;
import org.zillion.util.json.FastJsonUtil;

public class ClientTest {

	public static void main(String[] args) throws Exception {
		String src = "[1001]+[1001.0]";
		src = src.replaceAll("\\[1001\\]", "a");
		src = src.replaceAll("\\[1001\\.0\\]", "b");
		System.out.println(src);

		SSurvey survey = generate();

		ClientProxyFactoryBean factory = new ClientProxyFactoryBean();
		factory.setServiceClass(IService1.class);
		factory.setAddress("http://localhost:8080/compute-engine-webapp/services/Service1_WS");
		factory.setServiceFactory(new JaxWsServiceFactoryBean());
		factory.getServiceFactory().setDataBinding(new AegisDatabinding());
		IService1 client = (IService1) factory.create();
		SSurveyResult result = client.Survey_Update(survey);
		JSONObject json = (JSONObject) FastJsonUtil.To_JSON(result);
		System.out.println(FastJsonUtil.toFormatString(json));
	}

	static SSurvey generate() throws Exception {
		SSurvey result;

		JSONReader json_reader = new JSONReader(ResourceUtil.getUtf8Reader("survey.json"));
		Object jsonReaderObject = json_reader.readObject();
		FastJsonUtil.Normalize(jsonReaderObject);
		JSONObject json = (JSONObject) jsonReaderObject;
		result = (SSurvey) FastJsonUtil.To_JavaObject(json, SSurvey.class);

		return result;
	}
}
