package com.persagy.service;

import java.io.File;

import org.apache.cxf.aegis.databinding.AegisDatabinding;
import org.apache.cxf.frontend.ClientProxyFactoryBean;
import org.apache.cxf.jaxws.support.JaxWsServiceFactoryBean;
import org.zillion.util.json.FastJsonReaderUtil;
import org.zillion.util.json.FastJsonUtil;

import com.alibaba.fastjson.JSONObject;
import com.persagy.wsentity2.TSurvey;
import com.persagy.wsentity2.TSurveyResult;

public class ClientTest2 {

	public static void main(String[] args) throws Exception {
		String src = "[1001]+[1001.0]";
		src = src.replaceAll("\\[1001\\]", "a");
		src = src.replaceAll("\\[1001\\.0\\]", "b");
		System.out.println(src);

		TSurvey survey = generate();

		ClientProxyFactoryBean factory = new ClientProxyFactoryBean();
		factory.setServiceClass(IService1.class);
		factory.setAddress("http://localhost:8080/compute-engine-webapp/services/Service1_WS");
		factory.setServiceFactory(new JaxWsServiceFactoryBean());
		factory.getServiceFactory().setDataBinding(new AegisDatabinding());
		IService1 client = (IService1) factory.create();
		TSurveyResult result = client.Survey_Update2(survey);
		JSONObject json = (JSONObject) FastJsonUtil.To_JSON(result);
		System.out.println(FastJsonUtil.toFormatString(json));
	}

	static TSurvey generate() throws Exception {
		TSurvey result;

		JSONObject json = FastJsonReaderUtil.Instance()
				.ReadJSONObject(new File("D:\\Work\\Saga_Project_Compute\\compute-engine-webapp\\src\\main\\resources\\survey2-10101.json"));
		// result = (SSurvey) FastJsonUtil.To_JavaObject(Convertor_JSON.FastJson2SagaJson(json), TSurvey.class);
		result = (TSurvey) FastJsonUtil.To_JavaObject(json, TSurvey.class);

		return result;
	}
}
